import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Date;
import java.util.Properties;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.activation.URLDataSource;
import javax.mail.Authenticator;
import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

public class HtmlJavaMail {

	public static void main(String[] args) {
		HtmlJavaMail mjm = new HtmlJavaMail();
		mjm.sendMail();
	}

	public HtmlJavaMail() {}

	public void sendMail() {
		Properties props = new Properties();

		props.put("mail.smtp.host", MailSettings.smtpHost);
		props.put("mail.debug","true");
		Session session = Session.getDefaultInstance(props, new ForcedAuthenticator());

		Message message = new MimeMessage(session);

		try {
			message.setFrom(new InternetAddress(MailSettings.fromAddress,
					MailSettings.fromName));

			message.setRecipient(Message.RecipientType.TO, new InternetAddress(
					MailSettings.toAddress));

			message.setSubject(MailSettings.messageSubject);

			MimeMultipart multipart=new MimeMultipart();
			
			BodyPart msgBodyPart=new MimeBodyPart();
			msgBodyPart.setContent("<H1>Hi! From HtmlJavaMail</H1><img src=\"cid:logo\">","text/html");
			
			BodyPart embedImage=new MimeBodyPart();
			DataSource ds=new URLDataSource(new URL(MailSettings.inlineImage));
			embedImage.setDataHandler(new DataHandler(ds));
			embedImage.setHeader("Content-ID","<logo>");
			
			multipart.addBodyPart(msgBodyPart);
			multipart.addBodyPart(embedImage);
			
			message.setContent(multipart);

			message.setSentDate(new Date());

			Transport.send(message);

		} catch (AddressException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MessagingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	class ForcedAuthenticator extends Authenticator {
		public PasswordAuthentication getPasswordAuthentication() {
			return new PasswordAuthentication(MailSettings.smtpUsername,
					MailSettings.smtpPassword);
		}
	}
}
